// -------------------------------------------------------------------------------- 
//!  @file  bg.h                                                                    
//!  背景タスク処理のヘッダファイル                                                 
//                                                                                  
//   Copyright (C) 2021 lsluk, All rights reserved.                                 
//   http://vdmgr.g2.xrea.com/index.html                                            
// -------------------------------------------------------------------------------- 
#ifndef __BG__BG_H__INCLUDED__
#define __BG__BG_H__INCLUDED__


typedef struct _bgtcb				BGTCB ;							//!< 背景タスク TCB


typedef void (*BGSTAGEEVENTPROC)(BGTCB *p_parent, uint16_t param) ;	//!< ステージイベント処理

	//! 背景タスク TCB
	struct _bgtcb {
		TCBHEAD( SYSTEMTCB )										//!< TCB ヘッダ
		BGSTAGEEVENTPROC			stageEvent ;					//!< ステージイベント処理
		int24f8_t					x ;								//!< ｘ座標
		int24f8_t					y ;								//!< ｙ座標
		int8f8_t					speed ;							//!< 速度
		uint16_t					const *p_data ;					//!< データアドレス
		uint16_t					const *p_enemy ;				//!< 敵アドレス
		uint32_t					enemyCount ;					//!< 残り敵数
	} ;


extern void            bg_create(SYSTEMTCB *p_parent, int stage) ;
extern uint8_t RAMFUNC bg_checkHit(int24f8_t x, int24f8_t y) ;
extern uint8_t RAMFUNC bg_checkHitX(int24f8_t sx, int24f8_t sy, int24f8_t ex, int24f8_t *p_x) ;
extern uint8_t RAMFUNC bg_checkHitY(int24f8_t sx, int24f8_t sy, int24f8_t ey, int24f8_t *p_y) ;


// -------------------------------------------------------------------------------- 
//!  背景スクロール停止                                                             
//!                                                                                 
//!  @return なし                                                                   
// -------------------------------------------------------------------------------- 
static inline void bg_stopScroll( void )
{
	g.bg.status |= BG_STATUS_STOPSCROLL ;
}


#endif//__BG__BG_H__INCLUDED__
