// -------------------------------------------------------------------------------- 
//!  @file  enemy.h                                                                 
//!  敵タスク管理のヘッダファイル                                                   
//                                                                                  
//   Copyright (C) 2021 lsluk, All rights reserved.                                 
//   http://vdmgr.g2.xrea.com/index.html                                            
// -------------------------------------------------------------------------------- 
#ifndef __ENEMY__ENEMY_H__INCLUDED__
#define __ENEMY__ENEMY_H__INCLUDED__


#include "bg/bg.h"


typedef struct _enemytcb			ENEMYTCB ;						//!< 敵タスク TCB

	//! 敵タスク TCB
	struct _enemytcb {
		TCBHEAD( ENEMYTCB )											//!< TCB ヘッダ
		OBJ							obj ;							//!< オブジェクト
		uint16_t					param ;							//!< パラメータ
		int8f8_t					speed ;							//!< 速度
		uint8_t						angle ;							//!< 角度
		int24f8_t					xofs ;							//!< ｘ座標オフセット
		int24f8_t					yofs ;							//!< ｙ座標オフセット
		int16_t						shield ;						//!< シールド数
	} ;


extern void RAMFUNC enemy_create(int24f8_t y, uint16_t param) ;
extern void RAMFUNC enemy_destroy( ENEMYTCB *p_tcb ) ;
extern void RAMFUNC enemy_explosion(ENEMYTCB *p_tcb, uint8_t action, bool powerCapsule) ;


#endif//__ENEMY__ENEMY_H__INCLUDED__
