// -------------------------------------------------------------------------------- 
//!  @file  powercapsule.c                                                          
//!  パワーカプセルタスク処理のソースファイル                                       
//                                                                                  
//   Copyright (C) 2021 lsluk, All rights reserved.                                 
//   http://vdmgr.g2.xrea.com/index.html                                            
// -------------------------------------------------------------------------------- 
#include "common.h"
#include "enemy.h"
#include "powercapsule.h"


static void RAMFUNC powercapsule_040( ENEMYTCB *p_tcb ) ;


// -------------------------------------------------------------------------------- 
//!  パワーカプセル当たり処理                                                       
//!                                                                                 
//!  @param [in,out] p_self   自分                                                  
//!  @param [in,out] p_rival  相手                                                  
//!  @return                  なし                                                  
// -------------------------------------------------------------------------------- 
static void RAMFUNC powercapsule_hit(HIT *p_self, HIT *p_rival)
{
	ENEMYTCB	*p_tcb=MEMBERSTRUCT(ENEMYTCB, obj.hit, p_self) ;


	p_self->flag = 0 ;

	p_tcb->taskProc = enemy_destroy ;

	g.powerCapsule++ ;
	g.score++ ;

	sound_requestSE(3, SE_01) ;
}


// -------------------------------------------------------------------------------- 
//!  敵タスクのパワーカプセル表示                                                   
//!                                                                                 
//!  @param [in,out] p_tcb  敵タスク                                                
//!  @return                なし                                                    
// -------------------------------------------------------------------------------- 
void RAMFUNC powercapsule( ENEMYTCB *p_tcb )
{
	p_tcb->taskProc     = powercapsule_040 ;
	p_tcb->obj.hit.proc = powercapsule_hit ;

	obj_setAction(&p_tcb->obj, ACT_POWERCAPSULE) ;
}


static void RAMFUNC powercapsule_040( ENEMYTCB *p_tcb )
{
	p_tcb->obj.x -= toFp( g.bg.xofs ) ;
	if( (uint32_t )(getInt( p_tcb->obj.x )-8) >= (SCREEN_WIDTH+(8*2)) ) {
		enemy_destroy( p_tcb ) ;
		return ;
	}

	p_tcb->obj.y -= toFp( g.bg.yofs ) ;

	obj_updateAction( &p_tcb->obj ) ;
}
