// -------------------------------------------------------------------------------- 
//!  @file  hit.h                                                                   
//!  当たり管理のヘッダファイル                                                     
//                                                                                  
//   Copyright (C) 2021 lsluk, All rights reserved.                                 
//   http://vdmgr.g2.xrea.com/index.html                                            
// -------------------------------------------------------------------------------- 
#ifndef __HIT_H__INCLUDED__
#define __HIT_H__INCLUDED__


typedef void (*HITPROC)(HIT *p_self, HIT *p_rival) ;				//!< 当たり処理

	// 当たり情報フラグ
	enum {
		HIT_FLAG_BULLET				=	1 << 0,						//!< 弾
		HIT_FLAG_BODY				=	1 << 1,						//!< 本体
		HIT_FLAG_CAPSULE			=	1 << 2,						//!< カプセル
		HIT_FLAG_INDESTRUCTIBLE		=	1 << 3,						//!< 破壊不可能
		HIT_FLAG_JUDGE				=	1 << 6,						//!< 判定済み（タスクで使用可能）
		HIT_FLAG_ENEMY				=	1 << 7						//!< 敵
	} ;

	//! 当たり情報
	struct _hit {
		HITPROC						proc ;							//!< 処理
		uint16_t					x ;								//!< 開始ｘ座標
		uint8_t						y ;								//!< 開始ｙ座標
		uint8_t						w ;								//!< 幅
		uint8_t						h ;								//!< 高さ
		uint8_t						strength ;						//!< 強さ
		uint8_t						flag ;							//!< フラグ
		uint8_t						work ;							//!< 作業領域（タスクで使用可能）
	} ;


extern void RAMFUNC hit_init( void ) ;
extern bool RAMFUNC hit_set( OBJ *p_obj ) ;
extern void RAMFUNC hit_add( HIT *p_hit ) ;
extern void RAMFUNC hit_calc( void ) ;
extern void RAMFUNC hit_nothing(HIT *p_self, HIT *p_rival) ;


#endif//__HIT_H__INCLUDED__
