// -------------------------------------------------------------------------------- 
//!  @file  sound.h                                                                 
//!  サウンド管理のヘッダファイル                                                   
//                                                                                  
//   Copyright (C) 2021 lsluk, All rights reserved.                                 
//   http://vdmgr.g2.xrea.com/index.html                                            
// -------------------------------------------------------------------------------- 
#ifndef __SOUND_H__INCLUDED__
#define __SOUND_H__INCLUDED__


extern void sound_init( void ) ;
extern void RAMFUNC sound_vsync( void ) ;
extern void RAMFUNC sound_playBGM( int no ) ;
extern void RAMFUNC sound_stopBGM( void ) ;
extern void RAMFUNC sound_fadeOutBGM( void ) ;


// -------------------------------------------------------------------------------- 
//!  SE 再生リクエスト                                                              
//!                                                                                 
//!  @param [in] channel  チャンネル                                                
//!  @param [in] no       SE 番号                                                   
//!  @return              なし                                                      
// -------------------------------------------------------------------------------- 
static inline void sound_requestSE(int channel, uint8_t no)
{
	if( !g.requestSE[channel] ) {
		g.requestSE[channel] = no + 1 ;
	}
}


#endif//__SOUND_H__INCLUDED__
